#include "criteria.hpp"
#include "rows.hpp"

#include <cmath>  // for log2
#include <iostream>

namespace Tree_AG{

  // Split criteria
  
  // Compute the gini impurity for rows
  //
  float gini_impurity(Rows& rows, Rows_indexes& indexes){

    float impurity, p, p1;    
    Dictionary dict;
    unsigned int number_rows = indexes.size();
    Value v, v1;

    count_uniques(rows, indexes, dict);

    Dictionary::const_iterator it = dict.begin();
    Dictionary::const_iterator it_end = dict.end();
    Dictionary::const_iterator it1 = dict.begin();
    Dictionary::const_iterator it1_end = dict.end();

    impurity = 0.0;
    for (; it!=it_end; ++it){

      v = it->first;
      p = ((float) dict.occurrences(v)/number_rows);
      
      for(; it1!=it1_end; ++it1){

	if (it == it1) continue;
	v = it1->first;
	p1 = ((float) dict.occurrences(v)/number_rows);      
	
	impurity += p*p1;
      }
    }
    return impurity;
  }


  // Compute the entropy for rows
  //
  float entropy(Rows& rows, Rows_indexes& indexes){

    float entropy, p;    
    Dictionary dict;
    Value v;
    unsigned int number_rows = indexes.size();

    count_uniques(rows, indexes, dict);
    
    Dictionary::const_iterator it = dict.begin();
    Dictionary::const_iterator it_end = dict.end();

    entropy = 0.0;
    for (; it!=it_end; ++it){
      v = it->first;
      p = ((float) dict.occurrences(v)/number_rows);
      // std::cout << "v=" << v << " occ=" << dict.occurrences(v) 
      //     	<< " p=" << p << std::endl;
      entropy -= p*log2(p);
    }
    return entropy;
  }
};
