#ifndef DECISION_TREE
#define DECISION_TREE 1

#include "tree.hpp"
#include "rows.hpp"

namespace Tree_AG{

  class DecisionTree{
    
  public:
    DecisionTree(Rows& rows): rows_(rows){};

    
    // Split the dataset of Rows comparing column, with value stored in node
    //
    // @param current current row indexes
    // @param rows left   (OUT: left side of the split)
    // @param rows right  (OUT: right side of the split)
    // @param colum_index (column index where to split)
    // @param value       (comparison value);
    //
    void divide_set(Rows_indexes& current, 
		    Rows_indexes& left, Rows_indexes& right,
		    unsigned int column_index, Value& value);
    
    // Build tree
    //
    // @param rows_indexes indexes
    // @param score_function
    //
    Node* build_tree(Rows_indexes& indexes,
		     float(*score_function)(Rows&, Rows_indexes&)=&entropy);


  private:
    Rows rows_;
  };


  ////////////////////// FREE METHODS


  // Classify
  // 
  // 
  Dictionary classify(Row& new_observation, Node * node);

};


#endif
