#ifndef DICTIONARY_H 
#define DICTIONARY_H 1

#include <map>
#include "defs.hpp"

namespace Tree_AG{

  class Dictionary{

  public:
    typedef std::map<Value, unsigned int> Dict;
    typedef Dict::iterator iterator;
    typedef Dict::const_iterator const_iterator;

    bool contains(Value& v) { return d_[v] > 0; }
    void add(Value& v) { d_[v]++; }
    unsigned int occurrences(Value& v){ return d_[v]; }
    void clear(){ d_.clear(); }

    inline iterator begin() { return d_.begin(); }
    inline const_iterator begin() const { return d_.begin(); }
    inline iterator end() { return d_.end(); }
    inline const_iterator end() const { return d_.end(); }

  private:
    Dict d_;

    friend std::ostream& operator<< (std::ostream& os, 
				     const Dictionary& dict);
  };  
};

#endif
