#include "rows.hpp"

#include <boost/foreach.hpp>
#include <iostream>

namespace Tree_AG{

  // Compare two variants
  // 
  bool compare(Value& va, Value& vb)
  {
    const float *fa, *fb;
    const std::string *sa, *sb;
    if ( (fa = boost::get<float>(&va)) && 
	 (fb = boost::get<float>(&vb)) )
      
      return *fa >= *fb;
      
    else if ( (sa = boost::get<std::string>(&va)) && 
	      (sb = boost::get<std::string>(&vb)) )
      
      return *sa == *sb;

    else 
      throw("error comparison");  // we are not comparing apple to apple
  }

  // Count unique elements on Rows
  // 
  void count_uniques(Rows& rows, Rows_indexes& indexes, Dictionary& dict)
  {
    BOOST_FOREACH(Rows_indexes::value_type i, indexes){

      //std::cout << "considering rows[" << i << "]=" << rows[i] << std::endl;
      
      BOOST_FOREACH(Row::value_type v, rows[i]){
	
	dict.add(v);
      }
    }
  }

  // Dump a row
  // 
  std::ostream& operator << (std::ostream& os, const Row & row){
    
    BOOST_FOREACH(Row::value_type v, row){
      os << v << " ";
    }
    return os;
  }

  // Dump rows
  // 
  std::ostream& operator << (std::ostream& os, const Rows & rows){
    
    BOOST_FOREACH(Rows::value_type r, rows){
      os << "Row:" << r << std::endl;
    }
    return os;
  }

  std::ostream& operator << (std::ostream& os, const Rows_indexes & indexes){

    BOOST_FOREACH(Rows_indexes::value_type i, indexes){
      os << i << " ";
    }
    return os;
  }

};
