#include "tree.hpp"
#include "rows.hpp"
#include <boost/foreach.hpp>

namespace Tree_AG{


  ///////////////////// FREE METHOD


  // Depth first node
  // @param node n
  void depth_first(const Node& n, unsigned int level){
      
    std::cout << "(" << level << ")";
    Node::const_iterator it = n.begin();
    Node::const_iterator it_end = n.end();
    for (; it != it_end; ++it)
      if (! boost::is_null(it)){
	std::cout << *it;
	depth_first(*it, ++level);
      }
  }
  
  //////////////////////////////////////////////////////////////


  //
  // Dump a node
  // 
  std::ostream& operator << (std::ostream& os, const Node & n){

    if (n.column_index_ != -1){
      os << "split criteria (column_index=" << n.column_index_
	 << " , value=";
      
      if (const float * f = boost::get<float>(&n.value_))
	os << *f;
      else if (const std::string* s = boost::get<std::string>(&n.value_)){
      os << *s;
      }
      os << ")";
    }
    os << " dict=(" << n.d_ << ")" << std::endl;

    return os;
  }
 
};
